<?php

namespace Teknisa\ACL\Repositories;

use Teknisa\ACL\Util\InstanceProvider;

class Crud {

    protected $entityManager;
    protected $connection;

    /**
     * Crud constructor.
     */
    public function __construct()
    {
        $this->entityManager = InstanceProvider::getEntityManager();
        $this->connection = $this->entityManager->getConnection();
    }


    public function select($table, $fields = '*', $conditions = NULL, $organizationId = NULL)
    {
        $query = "SELECT {$fields} FROM {$table} {$conditions}";
        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($organizationId);
        $entityManager = $entityManager ? $entityManager: $this->entityManager;
        return $entityManager->getConnection()->fetchAll($query);
    }
    
    public function findCount($table, $conditions = NULL)
    {
        $query  = "SELECT COUNT(*) AS COUNT FROM {$table} {$conditions}";
        $result = $this->connection->fetchAll($query);
        return $result[0]["COUNT"];
    }

    public function findOne($table, $fields = '*', $conditions = NULL, $organizationId = NULL)
    {
        $data = self::select($table, $fields, $conditions, $organizationId);
        return !empty($data) ? $data[0] : null;
    }

    public function update($table, array $campos, $conditions, $organizationId = NULL)
    {
        foreach($campos as $key => $value){
            $fields[] = "{$key} = {$value}";
        }
        $fields = implode(', ', $fields);
        $query = "UPDATE {$table} SET {$fields} WHERE {$conditions}";
        $std = $this->connection->prepare($query);
        $std->execute();
    }

}